import 'package:realtime_client/realtime_client.dart';
import 'package:test/test.dart';

void main() {
  test('channel should be initially closed', () {
    final channel = RealtimeSubscription('topic', RealtimeClient('endpoint'));
    expect(channel.isClosed(), isTrue);
    channel.sendJoin(const Duration(seconds: 5));
    expect(channel.isJoining(), isTrue);
  });
  test('channel subscribe', () async {
    final socket =
        RealtimeClient('ws://wwswosyfqfwqjkmsprci.supabase.net/realtime/v1',
            params: {
              'apikey':
                  'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJyb2xlIjoiYW5vbiIsImlhdCI6MTYxMjQyMzU1NCwiZXhwIjoxOTI3OTk5NTU0fQ.AkkfN4q7KewkQk7vSZ-kI5BSQvea_2_HVPgtIY0vyPI'
            },
            logger: (kind, msg, data) => {print('$kind $msg $data')});
    // socket.onMessage((message) => print('MESSAGE $message'));
    socket.connect();

    final channel = socket.channel('realtime:public');
    channel.on('DELETE', (payload, {ref}) {
      print('channel delete payload: $payload');
    });
    channel.on('INSERT', (payload, {ref}) {
      print('channel insert payload: $payload');
    });
    channel.subscribe().receive('ok', (_) => print('SUBSCRIBED'));

    await Future.delayed(const Duration(seconds: 5), () {});
    socket.sendHeartbeat();

    await Future.delayed(const Duration(seconds: 50), () {});

    channel.unsubscribe();
    socket.disconnect();
    await Future.delayed(const Duration(seconds: 1), () {});
  }, timeout: const Timeout(Duration(seconds: 500)));
}
